// Copyright (C) 2000, Edward W. Felten.  All rights reserved.


public abstract class AbstractSecureConnection extends Connection {
  protected AbstractSecureConnection() {
    super();
  }

  protected AbstractSecureConnection(AbstractSecureConnection partner) {
    super(partner);
    startClntHandshake();
    partner.startServHandshake();
  }

  protected abstract void clientSideHandshake();

  protected abstract void serverSideHandshake();

  private void startClntHandshake() {
    new Thread() {
      public void run() {
	clientSideHandshake();
      }
    }.start();
  }

  private void startServHandshake() {
    new Thread() {
      public void run() {
	serverSideHandshake();
      }
    }.start();
  }
}
