// Copyright (C) 2000, Edward W. Felten.  All rights reserved.


public class AtmServer {
  private Connection conn;

  public AtmServer(Connection c) {
    conn = c;
    Runnable runnable = new Runnable() {
      public void run() {
	serverLoop();
      }
    };
    (new Thread(runnable)).start();
  }

  private void serverLoop() {
    ObjectConnection oc = new ObjectConnection(conn);
    try{
      for(;;){
	Account acct;
	Object obj = oc.receive();
	AtmCommand cmd = (AtmCommand)obj;
	switch(cmd.getKind()){
	case AtmCommand.Deposit:
	  acct = AccountDB.get(cmd.getAcctNum());
	  acct.deposit(cmd.getAmount());
	  oc.send(acct.getBalance());
	  break;
	case AtmCommand.Withdraw:
	  try{
	    acct = AccountDB.get(cmd.getAcctNum());
	    acct.withdraw(cmd.getAmount());
	    oc.send(acct.getBalance());
	  }catch(InsufficientFundsException x){
	    oc.send(x);
	  }
	  break;
	default:
	  System.err.println("AtmServer: illegal AtmCommand kind");
	  break;
	}
	// send back the balance
      }
    }catch(ConnectionClosedException x){
      // fall off the bottom and exit
    }
  }
}
