// Copyright (C) 2000, Edward W. Felten.  All rights reserved.


import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFrame;


public class Bank extends JFrame {
  private Bank() {
    super("First National Bank of COS 496");
    getContentPane().add(makeContents());
    pack();
    show();
  }

  private Component makeContents() {
    Box ret = Box.createHorizontalBox();
    JButton tBut = new JButton("Make teller terminal");
    tBut.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e){
	new TellerAuth();
      }
    });
    ret.add(tBut);
    JButton aBut = new JButton("Make ATM");
    aBut.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e){
	new ATM();
      }
    });
    ret.add(aBut);
    ret.add(new ExitButton("Quit"));
    return ret;
  }

  public static void main(String[] argv) {
    new Bank();
    for(;;)    Thread.yield();
  }
}
