// Copyright (C) 2000, Edward W. Felten.  All rights reserved.

import java.io.Serializable;


public class Money implements Serializable {
  private int x;

  public Money(int dollars, int cents) {
    x = dollars*100 + cents;
  }

  public Money(double d) {
    x = (int)(Math.floor(d*100.0));
  }

  public Money(String s) {
    this(Double.parseDouble(s));
  }

  public synchronized void add(Money m) {
    x += m.x;
  }

  public synchronized void subtract(Money m) 
    throws InsufficientFundsException {
    if(x < m.x)    throw new InsufficientFundsException();
    x -= m.x;
  }

  public String toString() {
    return "$" + x/100 + "." + (x/10)%10 + "" + x%10;
  }
}
