// Copyright (C) 2000, Edward W. Felten.  All rights reserved.

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;


public class ObjectConnection {
  Connection conn;

  public ObjectConnection(Connection c) {
    conn = c;
  }

  public void send(Object obj) throws ConnectionClosedException {
    try{
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      ObjectOutputStream oos = new ObjectOutputStream(baos);
      oos.writeObject(obj);
      oos.flush();
      byte[] arr = baos.toByteArray();
      conn.send(arr);
    }catch(IOException x){
      System.err.println("ObjectConnection::send: " + x);
    }
  }

  public Object receive() throws ConnectionClosedException {
    try{
      byte[] arr = conn.receive();
      ByteArrayInputStream bais = new ByteArrayInputStream(arr);
      ObjectInputStream ois = new ObjectInputStream(bais);
      return ois.readObject();
    }catch(IOException x){
      System.err.println("ObjectConnection::receive: " + x);
      return null;
    }catch(ClassNotFoundException x){
      System.err.println("ObjectConnection::receive: " + x);
      return null;
    }
  }

  public void close() {
    conn.close();
  }
}
