// Copyright (C) 2000, Edward W. Felten.  All rights reserved.

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;


public class TellerAuth extends JFrame {
  private LabeledTextField nameField;
  private LabeledTextField passwordField;

  public TellerAuth() {
    super("Teller Login");
    getContentPane().add(makeContents());
    pack();
    show();
  }

  private Component makeContents() {
    ActionListener al = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	String name = nameField.getText();
	String password = passwordField.getText();
	tryToAccept(name, password);
      }
    };

    nameField = new LabeledTextField("Name: ", "");
    passwordField = new LabeledTextField("Password: ", "");
	
    Box ret = Box.createVerticalBox();
    ret.add(nameField);
    ret.add(passwordField);
    JButton okButton = new JButton("OK");
    ret.add(okButton);

    nameField.addActionListener(al);
    passwordField.addActionListener(al);
    okButton.addActionListener(al);

    return ret;
  }

	    
  private void tryToAccept(String name, String password) {
    if(check(name, password)){
      accept(name);
    }else{
      nameField.setText("");
      passwordField.setText("");
      JOptionPane.showMessageDialog(null,
				    "Login failed --- try again.",
				    "Login failed",
				    JOptionPane.ERROR_MESSAGE);
    }
  }

  private boolean check(String name, String password) {
    return  password.equals(name);
  }

  private void accept(String tellerName) {
    try{
      new TellerUI();
      dispose();
    }catch(IOException x){
      System.err.println("Couldn't make TellerUI --- " + x);
    }
  }
}
